#include "StdAfx.h"
#include "Triangle.h"

CTriangle::CTriangle(void)
{
}


CTriangle::~CTriangle(void)
{
}


void CTriangle::OnInit(LPDIRECT3DDEVICE9 pd3dDevice, int* mode)
{
	m_pd3dDevice = pd3dDevice;

	if(*mode==0 || *mode==3)
	{
		CUSTOMVERTEX vertices[] = {
			{150.0f, 50.0f, 0.5f , 1.0f }, {250.0f, 250.0f, 0.5f, 1.0f }, {50.0f, 250.0f, 0.5f, 1.0f },
			{350.0f, 50.0f, 0.5f , 1.0f }, {450.0f, 250.0f, 0.5f, 1.0f }, {250.0f, 250.0f, 0.5f, 1.0f }
		};
		m_pd3dDevice->CreateVertexBuffer(6*sizeof(CUSTOMVERTEX), 0, D3DFVF_CUSTOMVERTEX, D3DPOOL_DEFAULT, &m_pVB, NULL);

		void* pVertices;
		m_pVB->Lock(0, sizeof(vertices), (void**)&pVertices, 0);
		memcpy(pVertices, vertices, sizeof(vertices));
	}

	else if(*mode==1 || *mode==2 || *mode==4 )
	{
		CUSTOMVERTEX vertices[] = {
			{50.0f, 250.0f, 0.5f, 1.0f },{150.0f, 50.0f, 0.5f , 1.0f }, 
			{250.0f, 250.0f, 0.5f, 1.0f },{350.0f, 50.0f, 0.5f , 1.0f },
			{450.0f, 250.0f, 0.5f, 1.0f }, {550.0f, 50.0f, 0.5f, 1.0f }
		};
		m_pd3dDevice->CreateVertexBuffer(6*sizeof(CUSTOMVERTEX), 0, D3DFVF_CUSTOMVERTEX, D3DPOOL_DEFAULT, &m_pVB, NULL);

		void* pVertices;
		m_pVB->Lock(0, sizeof(vertices), (void**)&pVertices, 0);
		memcpy(pVertices, vertices, sizeof(vertices));
	}

	else if(*mode==5)
	{
		CUSTOMVERTEX vertices[] = {
			{350.0f, 250.0f, 0.5f, 1.0f },{150.0f, 50.0f, 0.5f , 1.0f },{350.0f, 50.0f, 0.5f , 1.0f }, {550.0f, 50.0f, 0.5f, 1.0f }
		};
		m_pd3dDevice->CreateVertexBuffer(4*sizeof(CUSTOMVERTEX), 0, D3DFVF_CUSTOMVERTEX, D3DPOOL_DEFAULT, &m_pVB, NULL);

		void* pVertices;
		m_pVB->Lock(0, sizeof(vertices), (void**)&pVertices, 0);
		memcpy(pVertices, vertices, sizeof(vertices));
	}


	m_pVB->Unlock();
	
	m_pd3dDevice->SetRenderState(D3DRS_FILLMODE, D3DFILL_WIREFRAME);

}

void CTriangle::OnRender(int* mode)
{
	m_pd3dDevice->SetStreamSource(0, m_pVB, 0, sizeof(CUSTOMVERTEX));
	m_pd3dDevice->SetFVF(D3DFVF_CUSTOMVERTEX);
	switch(*mode)
	{
		case 0:
			m_pd3dDevice->DrawPrimitive(D3DPT_POINTLIST, 0, 6);
			break;
		case 1:
			m_pd3dDevice->DrawPrimitive(D3DPT_LINELIST, 0, 3);
			break;
		case 2:
			m_pd3dDevice->DrawPrimitive(D3DPT_LINESTRIP, 0, 5);
			break;
		case 3:
			m_pd3dDevice->DrawPrimitive(D3DPT_TRIANGLELIST, 0, 2);
			break;
		case 4:
			m_pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP, 0, 4);
			break;
		case 5:
			m_pd3dDevice->DrawPrimitive(D3DPT_TRIANGLEFAN, 0, 2);
			break;
	}
}

void CTriangle::OnRelease()
{
	if(m_pVB!=NULL)
		m_pVB->Release();
}